#!/usr/bin/env python
# -*- coding: utf-8 -*-

# An ES Tools replacement for CS:S by fratacos
# Version 0.86b

import es
import spe
import est
import gamethread
import os.path

es.ServerVar("est_dead_chat", 0, "enable/disable dead chat")
es.ServerVar("est_allowadvanceddrop", 0, "allow/disallow to drop unusual items")
es.ServerVar("est_enable_weapon_restrictions", 0, "enable/disable restrict weapon functions")
es.ServerVar("est_enable_weapon_mods", 0, "enable/disable modding weapon functions")
es.ServerVar("est_enable_PerUserKeyEvents", 0, "enable/disable est_client_keypress event")
es.ServerVar("est_enable_PerUserKeyHook", 0, "enable/disable ticklistener")
es.ServerVar("est_enable_gravity_reseting", 0, "enable/disable gravity resetting at ladders")

es.ServerVar("est_Hook_Cheatish", 0, "enable/disable hooking server-side cheat commands [es_tooks.cfg only]")
es.ServerVar("est_Hook_Kill", 0, "enable/disable hooking user 'kill' command [es_tooks.cfg only]")

es.ServerVar("est4css_nolegacy_support", 0, "disable pre-Orangebox compatible functionalities")
es.ServerVar("est4css_nosayfilter", 0, "disable the sayfilter function")

es.ServerVar("est_debug", 0)
es.ServerVar("est_conprint", 0)
es.ServerVar("est_Message_Mode", 0)
es.ServerVar("est_Max_Read_Line", 0)
es.ServerVar("est_Hook_Menu", 0)
es.ServerVar("est_Banned_Entities", 0)
es.ServerVar("est_enable_autorebuy_hook", 0)
es.ServerVar("est_enable_weapon_speed_mods", 0)
es.ServerVar("est_blackhole_size", 0)
es.ServerVar("est_blackhole_gravity", 0)
es.ServerVar("est_blackhole_pulse", 0)
es.ServerVar("est_blackhole_eats", 0)
es.ServerVar("est_Hook_Fire", 0)
es.ServerVar("est_Hook_Events_Matching", 0)
es.ServerVar("est_enable_est_bullet_impact", 0)
es.ServerVar("est_enable_est_player_shoot", 0)
es.ServerVar("est_enable_est_weapon_reload", 0)
es.ServerVar("est_enable_est_player_weapon_switch", 0)
es.ServerVar("est_enable_Anti_Crash", 0)

resourcepath = "addons/est/es_tools.res"

def est_help(command = ""):
	global reg_list
	if command == "":
		for key in reg_list:
			if key in alter_lower:
				upper = alter_lower[key]
			else:
				upper = key
			text1 = "%s - %s" % (upper, reg_list[key][5])
			text2 = "%s %s" % (upper, reg_list[key][4])
			es.printmsg("%s\n" % text1)
			es.printmsg("%s\n" % text2)
	elif command in reg_list:
		if command in alter_lower:
			upper = alter_lower[command]
		else:
			upper = command
		text1 = "%s - %s" % (upper, reg_list[command][5])
		text2 = "%s %s" % (upper, reg_list[command][4])
		es.printmsg("%s\n" % text1)
		es.printmsg("%s\n" % text2)

def est_credits():
	es.printmsg("""
---
est4css - yet another ES_Tools replacement for Counter-Strike:Source
\tby fratacos

[- PLUGIN and ADDON authors -]
\tEventScripts\t\t\tMattie
\tES_Tools\t\t\tAwuh0
\tSource Python Extensions\tyour-name-here
\tNativeTools\t\t\tChrisber

\tEST Commands\t\t\tfreddukes
\tFake Es_tools\t\t\tbonbon

[- DEBUG and TEST users -]
\tColonus, M41*, TOFU, 753, ABC, Lak, and kanachan.

[- SPECIAL THANKS TO -]
\tmicomico
\tL'In20Cible
\tblodia
\tforums.eventscripts.com
\tforums.alliedmods.net
\tand all users of this addon.
---
""")

alter_list = ["est_AddDownload", "est_Armor", "est_Armoradd", "est_Ban", "est_Burn", "est_CExec", "est_Cash", "est_CashAdd", "est_CloseFile", "est_CountEnts", "est_CountLines", "est_CvarAddFlag", "est_CvarDelFlag", "est_Damage", "est_Deafen", "est_DeathAdd", "est_DeathSet", "est_Deaths", "est_DeleteRagDolls", "est_Dissolve", "est_DropWeapon", "est_Drug", "est_Drunk", "est_Effect", "est_Extinguish", "est_Fade", "est_FileExists", "est_Freeze", "est_GetAmmo", "est_GetArmor", "est_GetChat", "est_GetClipAmmo", "est_GetDeaths", "est_GetEntClassName", "est_GetEntName", "est_GetEntityIndex", "est_GetEscort", "est_GetEventInfo", "est_GetEyeCoord", "est_GetFB", "est_GetGravity", "est_GetGun", "est_GetGunCoord", "est_GetHE", "est_GetHealth", "est_GetIndex", "est_GetIp", "est_GetKills", "est_GetLine", "est_GetName", "est_GetNamedOffset", "est_GetOffset", "est_GetPlayerDistance", "est_GetPlayerLocation", "est_GetPrimary", "est_GetSG", "est_GetSecondary", "est_GetSlot", "est_GetSteam", "est_GetTeam", "est_GetUserid", "est_GetViewAngle", "est_GetViewCoord", "est_GetViewPlayer", "est_GetViewProp", "est_GetWallBetween", "est_GetWeaponIndex", "est_Give", "est_God", "est_HasDefuser", "est_HasHelmet", "est_HasKevlar", "est_Health", "est_Healthadd", "est_HookKey", "est_IsAdmin", "est_IsAlive", "est_IsAlpha", "est_IsBomber", "est_IsNumeric", "est_IsOnly", "est_JetPack", "est_Kick", "est_KillAdd", "est_KillSet", "est_Kills", "est_KnifeOnly", "est_LightStyle", "est_LoadWeaponMod", "est_Loop", "est_MOTD_F", "est_MOTD_T", "est_MOLTD_W", "est_MakeAdmin", "est_MakeEntity", "est_ModPlayerWeapon", "est_MutePlayer", "est_Name", "est_Near", "est_NearCoord", "est_NoClip", "est_OpenFile", "est_PhysPush", "est_Play", "est_PlayEdict", "est_PlayPlayer", "est_PlayerCount", "est_PushTo", "est_RandPlayer", "est_RegClientCMD", "est_RegEventBlock", "est_RegSayHook", "est_Remove", "est_RemoveAdmin", "est_RemoveIdle", "est_RemoveWeapon", "est_Rescued", "est_Restrict", "est_RestrictAll", "est_Rocket", "est_RoundDecimal", "est_SetAim", "est_SetAmmo", "est_SetArmor", "est_SetCash", "est_SetClipAmmo", "est_SetEntModel", "est_SetEntName", "est_SetEntityColor", "est_SetEventInfo", "est_SetGravity", "est_SetHealth", "est_SetModel", "est_SetOffset", "est_SetPlayerColor", "est_SetViewAngle", "est_SetViewCoord", "est_Shake", "est_ShowMenu", "est_Slay", "est_Spawn", "est_Speed", "est_StopSound", "est_StrToUPPER", "est_StrTolower", "est_StripPlayer", "est_Strlen", "est_Team", "est_Teleport", "est_TrimDecimal", "est_UnRegClientCMD", "est_UnRegEventBlock", "est_UnRegSayHook", "est_UnRestrict", "est_UnRestrictAll", "est_entPhysPush", "est_entPushTo", "est_entTeleport", "est_modWeapon", "est_unHookKey", "est_unMutePlayer"]
for i in xrange(1, 35 + 1):
	alter_list.append("est_Effect_%02d" % i)
alter_lower = {}
for item in alter_list:
	alter_lower[item.lower()] = item

reg_list = {
"est_adddownload":[est.adddownload, 1, 1, 0, "<path>", ""],
"est_armor":[est.armor, 3, 3, 0, "<users> <+,-,=> <value>", ""],
"est_armoradd":[est.armoradd, 2, 2, 0, "<users> <value>", ""],
"est_ban":[est.ban, 2, 3, 0, "<users> <time> [reason]", ""],
"est_burn":[est.burn, 1, 2, 0, "<users> [time]", "burn 'em!"],
"est_cash":[est.cash, 3, 3, 0, "<users> <+,-,=> <value>", ""],
"est_cashadd":[est.cashadd, 2, 2, 0, "<users> <value>", ""],
"est_cexec":[est.cexec, 2, 999, 0, "<users> <command>", ""],
"est_closefile":[est.closefile, 1, 1, 0, "<fileid>", ""],
"est_countents":[est.countents, 2, 2, 1, "<variable> <entity name>", ""],
"est_countlines":[est.countlines, 2, 2, 1, "<variable> <fileid>", ""],
"est_credits":[est_credits, 0, 0, 0, "", ""],
"est_csay":[est.csay, 2, 2, 0, "<users> <text>", ""],
"est_curtime":[est.curtime, 1, 1, 1, "<variable>", "return the internal global time"],
"est_cvaraddflag":[est.cvaraddflag, 9, 9, 0, "<cvar> <gamedll> <protected> <sponly> <notify> <cheat> <userinfo> <unlogged> <replicated>", ""],
"est_cvardelflag":[est.cvardelflag, 9, 9, 0, "<cvar> <gamedll> <protected> <sponly> <notify> <cheat> <userinfo> <unlogged> <replicated>", ""],
"est_damage":[est.damage, 3, 3, 0, "<source user> <target users> <value>", "damage specific users"],
"est_deafen":[est.deafen, 5, 5, 0, "<users> <total time> <percent> <fadeout time> <fadeback time>", ""],
"est_deathadd":[est.deathadd, 2, 2, 0, "<users> <value>", ""],
"est_deaths":[est.deaths, 3, 3, 0, "<users> <+,-,=> <value>", "change the score board's deaths"],
"est_deathset":[est.deathset, 2, 2, 0, "<users> <value>", ""],
"est_deleteragdolls":[est.deleteragdolls, 0, 1, 0, "[users]", ""],
"est_dissolve":[est.dissolve, 1, 5, 0, "<class name> [type] [time] [origin] [magnitude]", "kill users with fancy effects"],
"est_dropweapon":[est.dropweapon, 2, 2, 0, "<users> <weapon name/slot>", ""],
"est_drug":[est.drug, 1, 2, 0, "<users> [time]", ""],
"est_drunk":[est.drunk, 1, 2, 0, "<users> [time]", ""],
"est_effect":[est.effect, 5, 99, 0, "<number> <users> <delay> <model/decal> <parameters>", ""],
"est_effect_01":[est.effect_1, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_02":[est.effect_2, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_03":[est.effect_3, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_04":[est.effect_4, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_05":[est.effect_5, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_06":[est.effect_6, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_07":[est.effect_7, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_08":[est.effect_8, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_09":[est.effect_9, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_10":[est.effect_10, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_11":[est.effect_11, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_12":[est.effect_12, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_13":[est.effect_13, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_14":[est.effect_14, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_15":[est.effect_15, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_16":[est.effect_16, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_17":[est.effect_17, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_18":[est.effect_18, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_19":[est.effect_19, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_20":[est.effect_20, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_21":[est.effect_21, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_22":[est.effect_22, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_23":[est.effect_23, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_24":[est.effect_24, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_25":[est.effect_25, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_26":[est.effect_26, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_27":[est.effect_27, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_28":[est.effect_28, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_29":[est.effect_29, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_30":[est.effect_30, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_31":[est.effect_31, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_32":[est.effect_32, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_33":[est.effect_33, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_34":[est.effect_34, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_effect_35":[est.effect_35, 5, 99, 0, "<users> <delay> <model/decal> <parameters>", ""],
"est_endround":[est.endround, 2, 2, 0, "<time> <reason>", ""],
"est_entphyspush":[est.entphyspush, 4, 4, 0, "<index> <x> <y> <z>", ""],
"est_entpushto":[est.entpushto, 5, 5, 0, "<index> <x> <y> <z> <force>", ""],
"est_entteleport":[est.entteleport, 4, 4, 0, "<index> <x> <y> <z>", ""],
"est_extinguish":[est.extinguish, 1, 1, 0, "<users>", ""],
"est_fade":[est.fade, 8, 8, 0, "<users> <type> <fadetime> <totaltime> <r> <g> <b> <a>", ""],
"est_fileexists":[est.fileexists, 2, 2, 1, "<variable> <path>", ""],
"est_freeze":[est.freeze, 2, 2, 0, "<users> <1,0>", ""],
"est_getammo":[est.getammo, 3, 3, 1, "<variable> <users> <weapon name/slot>", ""],
"est_getarmor":[est.getarmor, 2, 2, 1, "<variable> <users>", ""],
"est_getchat":[est.getchat, 2, 2, 1, "<variable> <users>", ""],
"est_getclipammo":[est.getclipammo, 3, 3, 1, "<variable> <users> <weapon name/slot>", ""],
"est_getdeaths":[est.getdeaths, 2, 2, 1, "<variable> <users>", ""],
"est_getentclassname":[est.getentclassname, 2, 2, 1, "<variable> <index>", ""],
"est_getentityindex":[est.getentityindex, 3, 3, 1, "<variable> <users> <classname>", ""],
"est_getentname":[est.getentname, 2, 2, 1, "<variable> <index>", ""],
"est_getescort":[est.getescort, 2, 2, 1, "<variable> <users>", ""],
"est_geteventinfo":[est.geteventinfo, 2, 2, 1, "<variable> <key name>", ""],
"est_geteyecoord":[est.geteyecoord, 4, 4, 0, "<users> <variable x> <variable y> <variable z>", ""],
"est_getfb":[est.getfb, 2, 2, 1, "<variable> <users>", ""],
"est_getgravity":[est.getgravity, 2, 2, 1, "<variable> <users>", ""],
"est_getgun":[est.getgun, 2, 2, 1, "<variable> <users>", "return an user's active weapon name"],
"est_getguncoord":[est.getguncoord, 4, 4, 0, "<users> <variable x> <variable y> <variable z>", ""],
"est_gethe":[est.gethe, 2, 2, 1, "<variable> <users>", ""],
"est_gethealth":[est.gethealth, 2, 2, 1, "<variable> <users>", ""],
"est_getindex":[est.getindex, 2, 2, 1, "<variable> <users>", ""],
"est_getip":[est.getip, 2, 2, 1, "<variable> <users>", ""],
"est_getkills":[est.getkills, 2, 2, 1, "<variable> <users>", ""],
"est_getline":[est.getline, 3, 3, 1, "<variable> <fileid> <line no>", ""],
"est_getname":[est.getname, 2, 2, 1, "<variable> <users>", ""],
"est_getnamedoffset":[est.getnamedoffset, 3, 3, 1, "<variable> <index> <property>", ""],
"est_getoffset":[est.getoffset, 3, 3, 1, "<variable> <index> <property>", ""],
"est_getplayerdistance":[est.getplayerdistance, 5, 5, 0, "<variable distance> <variable azimuth> <variable elevation> <users1> <users2>", ""],
"est_getplayerlocation":[est.getplayerlocation, 2, 2, 1, "<variable> <users>", ""],
"est_getprimary":[est.getprimary, 2, 2, 1, "<variable> <users>", ""],
"est_getsecondary":[est.getsecondary, 2, 2, 1, "<variable> <users>", ""],
"est_getsg":[est.getsg, 2, 2, 1, "<variable> <users>", ""],
"est_getslot":[est.getslot, 3, 3, 1, "<variable> <users> <weapon name/slot>", ""],
"est_getsteam":[est.getsteam, 2, 2, 1, "<variable> <users>", ""],
"est_getteam":[est.getteam, 2, 2, 1, "<variable> <users>", ""],
"est_getuserid":[est.getuserid, 2, 2, 1, "<variable> <users>", ""],
"est_getviewangle":[est.getviewangle, 4, 4, 0, "<users> <variable pitch> <variable yaw> <variable roll>", ""],
"est_getviewcoord":[est.getviewcoord, 4, 4, 0, "<users> <variable x > <variable y> <variable z>", ""],
"est_getviewprop":[est.getviewprop, 2, 2, 2, "<users> <variable>", ""],
"est_getviewplayer":[est.getviewplayer, 2, 2, 2, "<users> <variable>", ""],
"est_getwallbetween":[est.getwallbetween, 7, 7, 1, "<variable> <x1> <y1> <z1> <x2> <y2> <z2>", ""],
"est_getweaponindex":[est.getweaponindex, 3, 3, 1, "<variable> <users> <weapon name/slot>", ""],
"est_give":[est.give, 2, 2, 0, "<users> <string>", "give an item for users"],
"est_god":[est.god, 1, 2, 0, "<users> [1,0]", "make users no hurt and no death status"],
"est_hasdefuser":[est.hasdefuser, 2, 2, 1, "<variable> <users>", ""],
"est_hashelmet":[est.hashelmet, 2, 2, 1, "<variable> <users>", ""],
"est_haskevlar":[est.haskevlar, 2, 2, 1, "<variable> <users>", ""],
"est_health":[est.health, 2, 3, 0, "<users> <+,-,=,value> [value]", ""],
"est_healthadd":[est.healthadd, 2, 2, 0, "<users> <value>", ""],
"est_help":[est_help, 0, 1, 0, "[command name]", ""],
"est_hookkey":[est.hookkey, 2, 2, 0, "<users> <key name>", ""],
"est_hsay":[est.hsay, 2, 2, 0, "<users> <text>", ""],
"est_isadmin":[est.isadmin, 2, 2, 1, "<variable> <users>", ""],
"est_isalive":[est.isalive, 2, 2, 1, "<variable> <users>", ""],
"est_isalpha":[est.isalpha, 2, 2, 1, "<variable> <string>", ""],
"est_isbomber":[est.isbomber, 2, 2, 1, "<variable> <users>", ""],
"est_isnumeric":[est.isnumeric, 2, 2, 1, "<variable> <string>", ""],
"est_isonly":[est.isonly, 3, 3, 1, "<variable> <string> <check letters>", ""],
"est_jetpack":[est.jetpack, 2, 2, 0, "<users> <1,0>", "baloon fights?"],
"est_kick":[est.kick, 1, 2, 0, "<users> [reason]", ""],
"est_killadd":[est.killadd, 2, 2, 0, "<users> <value>", ""],
"est_kills":[est.kills, 3, 3, 0, "<users> <+,-,=> <value>", "change the score board's kills"],
"est_killset":[est.killset, 2, 2, 0, "<users> <value>", ""],
"est_knifeonly":[est.knifeonly, 2, 2, 1, "<variable> <users>", ""],
"est_lightstyle":[est.lightstyle, 2, 2, 0, "<render style> <a-z>", ""],
"est_loadweaponmod":[est.loadweaponmod, 1, 1, 0, "<file name>", ""],
"est_loop":[est.loop, 3, 3, 0, "<variable> <users> <command>", ""],
"est_makeadmin":[est.makeadmin, 1, 1, 0, "<steamid>", ""],
"est_makeentity":[est.makeentity, 5, 6, 6, "<entity name> <model> <x> <y> <z> [variable]", "create and spawn an entity"],
"est_modplayerweapon":[est.modplayerweapon, 3, 3, 0, "<users> <weapon> <value>", ""],
"est_modweapon":[est.modweapon, 2, 2, 0, "<weapon> <value>", ""],
"est_motd_f":[est.motd_f, 4, 4, 0, "<users> <title> <command> <path>", "show motd by files"],
"est_motd_t":[est.motd_t, 4, 4, 0, "<users> <title> <command> <text>", "show motd by text"],
"est_motd_w":[est.motd_w, 4, 4, 0, "<users> <title> <command> <url>", "show motd by URL"],
"est_msg":[est.msg, 2, 2, 0, "<users> <string>", "print message to specific users"],
"est_muteplayer":[est.muteplayer, 1, 1, 0, "<users>", "disallow specific users to chat"],
"est_name":[est.name, 2, 2, 0, "<users> <string>", "return an user's name"],
"est_near":[est.near, 5, 5, 0, "<variable> <users> <distance> <base user> <command>", ""],
"est_nearcoord":[est.nearcoord, 7, 7, 0, "<variable> <users> <distance> <x> <y> <z> <command>", ""],
"est_noclip":[est.noclip, 2, 2, 0, "<users> <1,0>", ""],
"est_openfile":[est.openfile, 3, 3, 1, "<variable> <flag(r/w)> <path>", ""],
"est_physpush":[est.physpush, 4, 4, 0, "<users> <x> <y> <z>", ""],
"est_play":[est.play, 2, 4, 0, "<users> <path> [duration] [volume]", ""],
"est_playedict":[est.playedict, 2, 4, 0, "<index> <path> [volume] [attenuation]", ""],
"est_playercount":[est.playercount, 2, 2, 1, "<variable> <users>", ""],
"est_playplayer":[est.playplayer, 2, 4, 0, "<users> <path> [volume] [attenuation]", ""],
"est_pushto":[est.pushto, 5, 5, 0, "<users> <x> <y> <z> <force>", ""],
"est_randplayer":[est.randplayer, 2, 2, 1, "<variable> <users>", ""],
"est_regclientcmd":[est.regclientcmd, 2, 2, 0, "<command> <1,0>", ""],
"est_regeventblock":[est.regeventblock, 2, 2, 0, "<event name> <command>", ""],
"est_regsayhook":[est.regsayhook, 2, 2, 0, "<text> <0=identical,1=partial>", ""],
"est_remove":[est.remove, 1, 1, 0, "<entity>", ""],
"est_removeadmin":[est.removeadmin, 0, 1, 0, "[steamid]", ""],
"est_removeidle":[est.removeidle, 1, 1, 0, "<weapon / weapon_...>", ""],
"est_removeweapon":[est.removeweapon, 2, 2, 0, "<users> <weapon name/slot>", ""],
"est_rescued":[est.rescued, 1, 1, 1, "<variable>", ""],
"est_restrict":[est.restrict, 2, 2, 0, "<users> <weapon>", "limit specific weapon for users"],
"est_restrictall":[est.restrictall, 1, 1, 0, "<users>", "limit all weapons, include knife,  for users"],
"est_rocket":[est.rocket, 1, 1, 0, "<users>", "jump, smoke, and explosion effects for users"],
"est_rounddecimal":[est.rounddecimal, 3, 3, 1, "<variable> <value> <places>", ""],
"est_setaim":[est.setaim, 3, 3, 0, "<source user> <target users> <z diff>", ""],
"est_setammo":[est.setammo, 3, 3, 0, "<users> <weapon name/slot> <value>", ""],
"est_setarmor":[est.setarmor, 2, 2, 0, "<users> <value>", ""],
"est_setcash":[est.setcash, 2, 2, 0, "<users> <value>", ""],
"est_setclipammo":[est.setclipammo, 3, 3, 0, "<users> <weapon name/slot> <value>", ""],
"est_setentitycolor":[est.setentitycolor, 5, 5, 0, "<index> <r> <g> <b> <a>", ""],
"est_setentmodel":[est.setentmodel, 2, 2, 0, "<indel> <model path>", ""],
"est_setentname":[est.setentname, 2, 2, 0, "<index> <name>", ""],
"est_seteventinfo":[est.seteventinfo, 2, 2, 0, "<key name> <value>", ""],
"est_setgravity":[est.setgravity, 2, 2, 0, "<users> <ratio>", ""],
"est_sethealth":[est.sethealth, 2, 2, 0, "<users> <value>", ""],
"est_setmodel":[est.setmodel, 2, 2, 0, "<users> <model path>", ""],
"est_setoffset":[est.setoffset, 2, 2, 0, "<index> <property> <value>", ""],
"est_setplayercolor":[est.setplayercolor, 5, 6, 0, "<users> <r> <g> <b> <a> [1:include weapon/0:player only]", ""],
"est_setviewangle":[est.setviewangle, 4, 4, 0, "<users> <pitch> <yaw> <roll>", ""],
"est_setviewcoord":[est.setviewcoord, 4, 4, 0, "<users> <x> <y> <y>", ""],
"est_shake":[est.shake, 4, 4, 0, "<users> <time> <distance> <value>", ""],
"est_showmenu":[est.showmenu, 3, 3, 0, "<time> <users> <text>", ""],
"est_slay":[est.slay, 1, 1, 0, "<users>", "commit users to suicide"],
"est_spawn":[est.spawn, 1, 2, 0, "<users> [1,0]", "(force) respawn users"],
"est_speed":[est.speed, 2, 2, 0, "<users> <speed>", "change users' speed (default=1.0)"],
"est_stopsound":[est.stopsound, 2, 2, 0, "<users> <path>", ""],
"est_stripplayer":[est.stripplayer, 2, 2, 0, "<users> <1,0>", ""],
"est_strlen":[est.strlen, 2, 2, 1, "<variable> <string>", ""],
"est_strtolower":[est.strtolower, 2, 2, 1, "<variable> <string>", ""],
"est_strtoupper":[est.strtoupper, 2, 2, 1, "<variable> <string>", ""],
"est_team":[est.team, 2, 2, 0, "<users> <team>", "change users' team without death"],
"est_teleport":[est.teleport, 4, 4, 0, "<users> <x> <y> <z>", ""],
"est_trimdecimal":[est.trimdecimal, 3, 3, 1, "<variable> <value> <places>", ""],
"est_unhookkey":[est.unhookkey, 2, 2, 0, "<users> <key name>", ""],
"est_unmuteplayer":[est.unmuteplayer, 1, 1, 0, "<users>", "allow specific users to chat"],
"est_unregclientcmd":[est.unregclientcmd, 1, 1, 0, "<command>", ""],
"est_unregeventblock":[est.unregeventblock, 1, 2, 0, "<event name> [command]", ""],
"est_unregsayhook":[est.unregsayhook, 1, 1, 0, "<text>", ""],
"est_unrestrict":[est.unrestrict, 2, 2, 0, "<users> <weapon>", ""],
"est_unrestrictall":[est.unrestrictall, 1, 1, 0, "<users>", ""],
"est_uptime":[est.uptime, 1, 1, 1, "<variable>", "return time differences between the server's startup and present"],
}
nouser_list = ["est_effect", "est_getplayerdistance", "est_showmenu"]
for key in reg_list:
	if not "<users>" in reg_list[key][4]:
		nouser_list.append(key)

def load():
	global reg_list
	thename = "/".join(__name__.split(".")[:-1])
	spe.parseINI("est_init/est_sig.ini")
	if os.path.exists("cstrike/%s" % resourcepath):
		es.loadevents('declare', resourcepath)
		es.loadevents(resourcepath)
	es.ServerVar("sv_hudhint_sound").set(0)
	register(reg_list.keys(), thename)

def register(items, thename):
	global reg_list
	key = items[0]
	items = items[1:]
	if not es.exists("command", key):
		es.regcmd(key, "%s/reg_cmd" % thename, reg_list[key][5])
		es.regclientcmd(key, "%s/client_cmd" % thename, reg_list[key][5])
		if key in alter_lower:
			upper = alter_lower[key]
			es.regcmd(upper, "%s/reg_cmd" % thename, reg_list[key][5])
			es.regclientcmd(upper, "%s/client_cmd" % thename, reg_list[key][5])
	if len(items) == 0:
		es.mexec("es_tools.cfg")
		gamethread.delayed(0.5, reghook)
		gamethread.delayed(1, est.load)
		return
	gamethread.delayed(0.01, register, (items, thename))

def reg_cmd(userid = None):
	global alter_list
	global reg_list
	global nouser_list
	name = es.getargv(0)
	if name in alter_list:
		name = name.lower()
	item = reg_list[name]
	argc = es.getargc() - 1
	if not (item[1] <= argc <= item[2]):
		if name in alter_lower:
			upper = alter_lower[name]
		else:
			upper = name
		text = "Syntax: %s %s" % (upper, item[4])
		if userid:
			es.cexec(userid, "echo %s" % text)
		else:
			es.printmsg("%s\n" % text)
		return
	func = item[0]
	if es.getargs():
		arglist = es.getargs().replace('"', '').split()
	else:
		arglist = ()
	if 1 <= item[3] <= len(arglist):
		del arglist[item[3] - 1]
	if argc != 0 and name not in nouser_list:
		arglist[0] = estfilter(arglist[0])
	if name in ("est_damage", "est_effect", "est_setaim", "est_showmenu"):
		arglist[1] = estfilter(arglist[1])
	if name == "est_getplayerdistance":
		arglist[3] = estfilter(arglist[3])
		arglist[4] = estfilter(arglist[4])
		ret = func(arglist[3], arglist[4])
		if ret != None:
			es.ServerVar(arglist[0]).set(ret[0])
			es.ServerVar(arglist[1]).set(ret[1])
			es.ServerVar(arglist[2]).set(ret[2])
		return
	if name in ("est_geteyecoord", "est_getguncoord", "est_getviewangle", "est_getviewcoord"):
		ret = func(arglist[0])
		if ret != None:
			es.ServerVar(arglist[1]).set(ret[0])
			es.ServerVar(arglist[2]).set(ret[1])
			es.ServerVar(arglist[3]).set(ret[2])
		return
	if name == "est_removeadmin" and len(arglist) == 0:
		if userid:
			arglist.append(es.getplayersteamid(userid))
		else:
			return
	if name == "est_cexec" and len(arglist) >= 3:
		arglist = [arglist[0], arglist[1:]]
	if 0 < item[3]:
		ret = func(*arglist)
		if ret != None:
			es.ServerVar(es.getargv(item[3])).set(ret)
	else:
		func(*arglist)

def client_cmd():
	userid = es.getcmduserid()
	if est.isadmin(userid):
		reg_cmd(userid)
	else:
		es.cexec(userid, "echo Unknown command: %s" % es.getargv(0))

def estfilter(users):
	if not str(users).startswith("#"):
		return users
	users = users.replace("t", "2")
	users = users.replace("c", "3")
	return users

def unload():
	est.unload()

def reghook():
	# cmdlib cannot replace default commands ...
	thename = "/".join(__name__.split(".")[:-1])
	if es.getInt("est_Hook_Cheatish") != 0:
		global hook_cmds
		for item in hook_cmds:
			es.regcmd(item, "%s/donothing" % thename)
	if es.getInt("est_Hook_Kill") != 0:
		es.regcmd("kill", "%s/donothing" % thename)
	if es.getInt("est4css_nolegacy_support"):
		return
	es.forcevalue("sv_disablefreezecam", 1)
	es.forcevalue("sv_nowinpanel", 1)
	es.forcevalue("sv_legacy_grenade_damage", 1)
	es.forcevalue("sv_enablebunnyhopping", 1)
	es.forcevalue("sv_enableboost", 1)
	es.forcevalue("mp_round_restart_delay", 5)
	#still buggy, experimental implementation
	#es.regcmd("es", "%s/fake_es" % thename)
	es.regcmd("es_msg", "%s/fake_es_msg" % thename)
	es.regcmd("es_xmsg", "%s/fake_es_msg" % thename)
	es.regcmd("es_tell", "%s/fake_es_tell" % thename)
	es.regcmd("es_xtell", "%s/fake_es_tell" % thename)
	es.regcmd("es_centermsg", "%s/fake_es_centermsg" % thename)
	es.regcmd("es_xcentermsg", "%s/fake_es_centermsg" % thename)
	es.regcmd("es_centertell", "%s/fake_es_centertell" % thename)
	es.regcmd("es_xcentertell", "%s/fake_es_centertell" % thename)
	es.regcmd("es_toptext", "%s/fake_es_toptext" % thename)
	es.regcmd("es_xtoptext", "%s/fake_es_toptext" % thename)
	es.regcmd("es_set", "%s/fake_es_set" % thename)
	es.regcmd("es_xset", "%s/fake_es_set" % thename)

def donothing():
	pass

def fake_es():
	text = es.getargs()
	if text.startswith("es_xforeachkey"):
		es.ServerCommand(text)
		return
	if text.startswith("es_x") and not text.startswith("es_xelse") and not text.startswith("es_xif"):
		text = "es_%s" % text[4:]
		es.ServerCommand(text)
		return
	omitted = text = es.getargs()
	quotation = 0
	for i, item in enumerate(omitted):
		if quotation:
			omitted = "%s %s" % (omitted[:i], omitted[i:])
		if item == '"':
			quotation = 1 - quotation
	index = 0
	while True:
		index = omitted.find("event_var(", index)
		if index == -1:
			break
		brace = omitted.find(")", index + 1)
		if brace == -1:
			break
		name = omitted[index + 10:brace]
		omitted = "%s%s%s" % (omitted[:index], es.event_var[name], omitted[brace + 1:])
		text = text[:index] + text[index:].replace("event_var(%s)" % name, es.event_var[name], 1)
		index = brace + 1
	index = 0
	while True:
		index = omitted.find("server_var(", index)
		if index == -1:
			break
		brace = omitted.find(")", index + 1)
		if brace == -1:
			break
		name = omitted[index + 11:brace]
		text = text[:index] + text[index:].replace("server_var(%s)" % name, es.getString(name), 1)
		index = brace + 1
	es.ServerCommand(text)

def fake_es_expand(text):
	index = 0
	while True:
		index = text.find("event_var(", index)
		if index == -1:
			break
		brace = text.find(")", index + 1)
		if brace == -1:
			break
		name = text[index + 10:brace]
		text = text.replace("event_var(%s)" % name, es.event_var[name])
		index = brace + 1
	index = 0
	while True:
		index = text.find("server_var(", index)
		if index == -1:
			break
		brace = text.find(")", index + 1)
		if brace == -1:
			break
		name = text[index + 11:brace]
		text = text.replace("server_var(%s)" % name, es.getString(name))
		index = brace + 1
	return text

def fake_es_msg():
	argc = es.getargc()
	if argc <= 1:
		es.printmsg("Syntax: es_xmsg Please provide a message to broadcast.")
		return
	text = es.getargs()
	if not es.getargv(0).startswith("es_x"):
		text = fake_es_expand(text)
	if text.startswith("#"):
		temp = text.split(" ", 1)
		es.msg(temp[0], temp[1])
	else:
		es.msg(text)

def fake_es_tell():
	argc = es.getargc()
	if argc <= 2:
		es.printmsg("Syntax: %s <userid> [color] <message>" % es.getargv(0))
		return
	text = es.getargs().split(" ", 1)[1]
	if not es.getargv(0).startswith("es_x"):
		text = fake_es_expand(text)
	if text.startswith("#"):
		temp = text.split(" ", 1)
		es.tell(es.getargv(1), temp[0], temp[1])
	else:
		es.tell(es.getargv(1), text)

def fake_es_centermsg():
	argc = es.getargc()
	if argc <= 1:
		es.printmsg("Syntax: %s <string>" % es.getargv(0))
		return
	text = es.getargs()
	if not es.getargv(0).startswith("es_x"):
		text = fake_es_expand(text)
	es.centermsg(text)

def fake_es_centertell():
	argc = es.getargc()
	if argc <= 2:
		es.printmsg("Syntax: %s <userid> <string>" % es.getargv(0))
		return
	text = es.getargs()
	if not es.getargv(0).startswith("es_x"):
		text = fake_es_expand(text)
	data = es.getargs().split(" ", 1)
	es.centertell(data[0], data[1])

def fake_es_toptext():
	argc = es.getargc()
	if argc <= 3:
		es.printmsg("Syntax: %s <userid> <duration> [color] <message>" % es.getargv(0))
		return
	text = es.getargs()
	if not es.getargv(0).startswith("es_x"):
		text = fake_es_expand(text)
	data = text.split(" ", 2)
	if data[2].startswith("#"):
		temp = data[2].split(" ", 1)
		es.toptext(data[0], data[1], temp[0], temp[1])
	es.toptext(data[0], data[1], data[2])

def fake_es_set():
	argc = es.getargc()
	command = es.getargv(0)
	if argc <= 2:
		es.printmsg("Syntax: es_set")
		return
	data = es.getargs().split(" ", 1)
	if not es.getargv(0).startswith("es_x"):
		data[1] = fake_es_expand(data[1])
	data[1] = data[1].strip('"')
	es.ServerVar(data[0]).set(data[1])

def es_map_start(event_var):
	es.loadevents(resourcepath)
	est.es_map_start(event_var)

def es_client_command(event_var):
	est.es_client_command(event_var)

def round_start(event_var):
	est.round_start(event_var)

def round_end(event_var):
	est.round_end(event_var)

def player_activate(event_var):
	est.player_activate(event_var)

def player_connect(event_var):
	est.player_connect(event_var)

def player_death(event_var):
	est.player_death(event_var)

def player_jump(event_var):
	if es.getInt("est_enable_gravity_reseting"):
		est.player_jump(event_var)

def weapon_fire(event_var):
	est.weapon_fire(event_var)

def item_pickup(event_var):
	est.item_pickup(event_var)

def hostage_follows(event_var):
	est.hostage_follows(event_var)

def hostage_stops_following(event_var):
	est.hostage_stops_following(event_var)

def hostage_rescued(event_var):
	est.hostage_rescued(event_var)

# cheat, dump, entity, graphic, test/debug and other commands which I don't know
hook_cmds = [
"box", "buddha", "bug", "bug_swap", "camortho", "ch_createairboat", "ch_createjeep", "cl_dump_particlestats", "cl_ent_absbox", "cl_ent_bbox", "cl_ent_rbox", "cl_find_ent", "cl_find_ent_index", "cl_fullupdate", "cl_panelanimation", "cl_particles_dump_effects", "cl_precacheinfo", "cl_pred_track", "cl_removedecals", "cl_showents", "cl_soundemitter_flush", "cl_soundscape_flush", "cl_soundscape_printdebuginfo", "cl_view", "clear", "clear_debug_overlays", "cmd", "collisio_test", "commentary_cvarsnotchanging", "commentary_finishnode", "commentary_showmodelviewer", "commentary_testfirstrun", "condump", "create_flashlight", "CreateHairball", "CreatePredictionError", "creditsdone", "cs_make_vip", "dbghist_addline", "dbghist_dump", "debugsystemui", "devshots_nextmap", "devshots_screenshot", "differences", "dlight_debug", "drawcross", "drawline", "dsp_reload", "dti_flush", "dump_entity_sizes", "dump_globals", "dump_panels", "dump_particlemanifest", "dump_x360_cfg", "dump_x360_saves", "dumpentityfactories", "dumpeventqueue", "dumpgamestringtable", "dumpsavedir", "dumpstringtables", "editor_toggle", "endmovie", "ent_abbox", "ent_attachments", "ent_autoaim", "ent_bbox", "ent_cancelpendingentfires", "ent_create", "ent_dump", "ent_fire", "ent_info", "ent_keyvalue", "ent_messages", "ent_name", "ent_orient", "ent_pause", "ent_pivot", "ent_rbox", "ent_remove", "ent_remove_all", "ent_rotate", "ent_setname", "ent_step", "ent_teleport", "ent_text", "ent_viewoffset", "envmap", "explode", "explodevector", "fadein", "fadeout", "find", "find_ent", "fid_ent_index", "findflags", "firetarget", "firstperson", "flush", "flush_locked", "fogui", "force_centerview", "fov", "fs_printopenfiles", "fs_warning_level", "g15_dumpplayer", "g15_reload", "gamemenucommand", "give", "givecurrentammo", "global_set", "god", "groundlist", "hammer_update_entity", "hammer_update_safe_entities", "heartbeat", "hideradar", "hurtme", "impulse", "incrementvar", "item_show_whitelistable_definitions", "joyadvancedupdate", "kdtree_test", "key_findbinding", "key_listboundkeys", "key_updatelayout", "killserver", "light_crosshair", "lightprobe", "linefile", "listmodels", "listRecentNPCSpeech", "load", "loadcommentary", "mat_crosshair", "mat_crosshair_edit", "mat_crosshair_explorer", "mat_crosshair_printmaterial", "mat_crosshair_reloadmaterial", "mat_edit", "mat_hdr_enabled", "mat_info", "mat_reloadallmaterials", "mat_reloadmaterial", "mat_reloadtextures", "mat_reporthwmorphmemory", "mat_savechanges", "mat_setvideomode", "mat_showmaterials", "mat_showmaterialsverbose", "mat_showtextures", "mat_spewvertexandpixelshaders", "mat_texture_list_txlod", "mat_texture_list_txlod_sync", "multva", "nb_command", "nb_debug", "nb_debug_filter", "nb_delete_all", "nb_force_look_at", "nb_move_to_cursor", "nb_select", "nb_warp_selected_here", "net_channels", "net_start", "net_status", "noclip", "notarget", "overview_alpha", "overview_health", "overview_locked", "overview_mode", "overview_names", "overview_tracks", "overview_zoom", "particle_test_start", "particle_test_stop", "path", "perfui", "perfvisualbenchmark", "perfvisualbenchmark_abort", "physics_budget", "physics_constraints", "physics_debug_entity", "physics_highlight_active", "physics_report_active", "physics_select", "picker", "pixelvis_debug", "prop_crosshair", "prop_debug", "prop_dynamic_create", "prop_phsics_create", "r_3dnow", "r_cheapwaterend", "r_cheapwaterstart", "r_cleardecals", "r_flushlod", "r_printdecalinfo", "r_screenoverlay", "r_shadowangles", "r_shadowblobbycutoff", "r_shadowcolor", "r_shadowdir", "r_shadowdist", "r_sse2", "recompute_speed", "refresh_options_dialog", "report_simthinklist", "report_soundpatch", "report_touchlinks", "respawn_entities", "rr_reloadresponsesystems", "scene_flush", "setang", "setang_exact", "setmaster", "setmodel", "setpause", "setpos", "setpos_exact", "shake", "shake_stop", "showbudget_texture_global_dumptats", "showtriggers_toggle", "speak", "spike", "star_memory", "surfaceprop", "Test_CreateEntity", "test_dispatcheffect", "Test_EHandle", "test_entity_blocker", "test_freezeframe", "Test_InitRandomEntitySpawner", "Test_ProxyToggle_EnableProxy", "Test_ProxyToggle_EnsureValue", "Test_ProxyToggle_SetValue", "Test_RandomizeInPVS", "Test_RandomPlayerPosition", "Test_RemoveAllRandomEntities", "Test_SpawnRandomEntities", "testhudanim", "thirdperson", "thirdperson_mayamode", "TrackerAnim", "vehicle_flushscript", "viewanim_addkeyframe", "viewanim_create", "viewanim_load", "viewanim_reset", "viewanim_save", "viewanim_test", "voice_modenable", "voice_printtalkers", "+voicerecord", "-voicerecord", "vox_reload", "voxeltree_box", "voxeltree_playerview", "voxeltree_sphere", "voxeltree_view", "vprof", "vprof_adddebuggroup1", "vprof_cachemiss", "vprof_cachemiss_off", "vprof_cachemiss_on", "vprof_child", "vprof_collapse_all", "vprof_dump_groupnames", "vprof_expand_all", "vprof_expand_group", "vprof_generate_report", "vprof_generate_report_AI", "vprof_generate_report_AI_only", "vprof_generate_report_budget", "vprof_generate_report_hierarchy", "vprof_generate_report_map_load", "vprof_nextsibling", "vprof_off", "vprof_on", "vprof_parent", "vprof_playback_average", "vprof_playback_start", "vprof_playback_step", "vprof_playback_stepback", "vprof_playback_stop", "vprof_prevsibling", "vprof_record_start", "vprof_record_stop", "vprof_remote_start", "vprof_remote_stop", "vprof_reset", "vprof_reset_peaks", "vprof_vtune_group", "vtune", "wc_air_edit_further", "wc_air_edit_nearer", "wc_air_node_edit", "wc_create", "wc_destroy", "wc_destroy_undo", "wc_link_edit", "wipe_nav_attributes",
]